# Method: monetization.onetimeproducts.batchUpdate

- [HTTP request](https://developers.google.com/android-publisher/api-ref/rest/v3/monetization.onetimeproducts/batchUpdate#body.HTTP_TEMPLATE)
- [Path parameters](https://developers.google.com/android-publisher/api-ref/rest/v3/monetization.onetimeproducts/batchUpdate#body.PATH_PARAMETERS)
- [Request body](https://developers.google.com/android-publisher/api-ref/rest/v3/monetization.onetimeproducts/batchUpdate#body.request_body)
  - [JSON representation](https://developers.google.com/android-publisher/api-ref/rest/v3/monetization.onetimeproducts/batchUpdate#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://developers.google.com/android-publisher/api-ref/rest/v3/monetization.onetimeproducts/batchUpdate#body.response_body)
  - [JSON representation](https://developers.google.com/android-publisher/api-ref/rest/v3/monetization.onetimeproducts/batchUpdate#body.BatchUpdateOneTimeProductsResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://developers.google.com/android-publisher/api-ref/rest/v3/monetization.onetimeproducts/batchUpdate#body.aspect)
- [UpdateOneTimeProductRequest](https://developers.google.com/android-publisher/api-ref/rest/v3/monetization.onetimeproducts/batchUpdate#UpdateOneTimeProductRequest)
  - [JSON representation](https://developers.google.com/android-publisher/api-ref/rest/v3/monetization.onetimeproducts/batchUpdate#UpdateOneTimeProductRequest.SCHEMA_REPRESENTATION)
- [Try it!](https://developers.google.com/android-publisher/api-ref/rest/v3/monetization.onetimeproducts/batchUpdate#try-it)

Creates or updates one or more one-time products.

### HTTP request

`POST https://androidpublisher.googleapis.com/androidpublisher/v3/applications/{packageName}/oneTimeProducts:batchUpdate`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `packageName` | `string` Required. The parent app (package name) for which the one-time products should be updated. Must be equal to the packageName field on all the OneTimeProduct resources. |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "requests": [ { object (`https://developers.google.com/android-publisher/api-ref/rest/v3/monetization.onetimeproducts/batchUpdate#UpdateOneTimeProductRequest`) } ] } ``` |

| Fields ||
|---|---|
| `requests[]` | ``object (`https://developers.google.com/android-publisher/api-ref/rest/v3/monetization.onetimeproducts/batchUpdate#UpdateOneTimeProductRequest`)`` Required. A list of update requests of up to 100 elements. All requests must update different one-time products. |

### Response body

Response message for BatchUpdateOneTimeProduct.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "oneTimeProducts": [ { object (`https://developers.google.com/android-publisher/api-ref/rest/v3/monetization.onetimeproducts#OneTimeProduct`) } ] } ``` |

| Fields ||
|---|---|
| `oneTimeProducts[]` | ``object (`https://developers.google.com/android-publisher/api-ref/rest/v3/monetization.onetimeproducts#OneTimeProduct`)`` The list of updated one-time products list, in the same order as the request. |

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/androidpublisher`

## UpdateOneTimeProductRequest

Request message for onetimeproducts.patch.

| JSON representation |
|---|
| ``` { "oneTimeProduct": { object (`https://developers.google.com/android-publisher/api-ref/rest/v3/monetization.onetimeproducts#OneTimeProduct`) }, "updateMask": string, "regionsVersion": { object (`https://developers.google.com/android-publisher/api-ref/rest/v3/RegionsVersion`) }, "allowMissing": boolean, "latencyTolerance": enum (`https://developers.google.com/android-publisher/api-ref/rest/v3/ProductUpdateLatencyTolerance`) } ``` |

| Fields ||
|---|---|
| `oneTimeProduct` | ``object (`https://developers.google.com/android-publisher/api-ref/rest/v3/monetization.onetimeproducts#OneTimeProduct`)`` Required. The one-time product to upsert. |
| `updateMask` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#field-mask` format)`` Required. The list of fields to be updated. This is a comma-separated list of fully qualified names of fields. Example: `"user.displayName,photo"`. |
| `regionsVersion` | ``object (`https://developers.google.com/android-publisher/api-ref/rest/v3/RegionsVersion`)`` Required. The version of the available regions being used for the one-time product. |
| `allowMissing` | `boolean` Optional. If set to true, and the one-time product with the given packageName and productId doesn't exist, the one-time product will be created. If a new one-time product is created, updateMask is ignored. |
| `latencyTolerance` | ``enum (`https://developers.google.com/android-publisher/api-ref/rest/v3/ProductUpdateLatencyTolerance`)`` Optional. The latency tolerance for the propagation of this product upsert. Defaults to latency-sensitive. |